daftarjadwal/urls.py
from django.urls import path
from . import views

app_name = 'daftarjadwal'

urlpatterns = [
    path('susunjadwal', views.create, name='create'),
    path('daftarjadwal', views.index),
    path('cariJadwal', views.cariJadwal),
    path('update/<int:update_id>', views.update, name='update'),
    path('delete/<int:delete_id>', views.delete, name='delete'),
]

faq/urls.py
from django.urls import path
from . import views

app_name = 'faq'

urlpatterns = [
    path('', views.index, name='faq'),
    path('list-faq/', views.ViewQuestion, name='list_faq'),
    path('list/', views.getQuestions, name='get_faq'),
]

home/urls.py
from django.urls import path
from . import views

app_name = 'homepage'

urlpatterns = [
    path('login/', views.masuk, name = 'login'),
    path('daftar/', views.baru, name='daftar'),
    path('logout/', views.keluar, name='logout'),
]

tk2ppw/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('homepage.urls')),
    path('home/', include(('home.urls', 'home'), namespace='home')),
    path('daftarjadwal/', include('daftarjadwal.urls')),
    path('artikelpage/', include('artikelpage.urls')),
    path('faq/', include('faq.urls')),
    path('feedback/', include('feedback.urls')),
]

daftarjadwal/models.py
from django.db import models
from django.core.exceptions import ValidationError
# Create your models here.
# memvalidasi di model krn yg ingin di validasi model 

def validate_author(value):
    judul_input = value
    if judul_input == "Einstein":
        message = "maaf" + judul_input + "tidak bisa diposting"
        raise ValidationError(message)

class PostModel(models.Model):
    namaMatkul = models.CharField(max_length = 150)
    namaTugas = models.TextField(
        max_length=300,
        validators= [validate_author]
        )
    LIST_SEMESTER = [
        ('Gasal 2020/2021', 'Gasal 2020/2021'),
        ('Genap 2020/2021', 'Genap 2020/2021'),
        ('Gasal 2019/2020', 'Gasal 2019/2020'),
        ('Genap 2019/2020', 'Genap 2019/2020'),
        ('Gasal 2018/2019', 'Gasal 2018/2019'),
        ('Genap 2018/2019', 'Genap 2018/2019'),
        ('Gasal 2017/2018', 'Gasal 2017/2018'),
        ('Genap 2017/2018', 'Genap 2017/2018'),
    ]
    semester = models.CharField(max_length = 100, choices = LIST_SEMESTER)
    Deadline = models.DateField()
    published = models.DateTimeField(auto_now_add=True)
    
def __str__(self):
    return "{}.{}".format(self.id, self.judul)

daftarjadwal/forms.py
from django import forms

#import model dari models.py
from .models import PostModel

class PostForm(forms.ModelForm):
    class Meta:
        model = PostModel
        fields = [
            'namaMatkul',
            'namaTugas',
            'Deadline',
            'semester',           
        ]
        widgets = {
            'namaMatkul': forms.TextInput(  
                attrs={
                    'class' : 'form-control', 
                    'placeholder' : 'Tuliskan nama Mata kuliah',
                }
            ),
            'namaTugas': forms.TextInput(  
                attrs={
                    'class' : 'form-control',
                    'placeholder' : 'Tuliskan nama tugas anda',
                }
            ),
            'semester': forms.Select(  
                attrs={
                    'class' : 'form-control', 
                }
            ),        
            'Deadline': forms.DateInput(attrs={'type':'date'}),
        }
# pada bagian ini form susun deadline memiliki tiga data yang harus disubmit oleh pengguna

daftarjadwal/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from django.db.models import Q
# Create your views here.
from .forms import *
from .models import PostModel

def index(request):
    posts = PostModel.objects.all()
    context = {
        'heading' : 'Post',
        'contents': 'List Post',
        'posts' : posts,
    }
    return render(request, 'daftarjadwal.html', context)

def create(request):
    post_form = PostForm(request.POST or None)
    if request.method == 'POST':
        #cara ambil data dari input user ke database dg validasi
        if post_form.is_valid():
            post_form.save()
        return HttpResponseRedirect("daftarjadwal")

    
    context = {
        'pageTitle' : 'Create Form',
        'post_form' : post_form,
    }
    return render(request, 'susunjadwal.html', context)

def update(request, update_id):
    akun_update = PostModel.objects.get(id=update_id)
    data = {
        'namaMatkul' : akun_update.namaMatkul,
        'namaTugas' : akun_update.namaTugas,
        'semester' : akun_update.semester,
        'Deadline' : akun_update.Deadline,
    }
    post_form = PostForm(request.POST or None, initial=data, instance=akun_update)

    if request.method == 'POST':
        #cara ambil data dari input user ke database dg validasi
        if post_form.is_valid():
            post_form.save()
        return HttpResponseRedirect("/daftarjadwal/daftarjadwal")

    
    context = {
        'pageTitle' : 'Update Form',
        'post_form' : post_form,
    }
    return render(request, '/susunjadwal.html', context)

def delete(request, delete_id):
    PostModel.objects.filter(id=delete_id).delete()
    return HttpResponseRedirect("/daftarjadwal/daftarjadwal")


def cariJadwal(request):
    context = {}
    query = request.GET.get('search', False)
    context['query'] = query
    if query:
        cari = PostModel.objects.filter(Q(namaMatkul__icontains=query) |
                                       Q(namaTugas__icontains=query) )
        if cari:
            context['hasil'] = cari
        else:
            context['hasil'] = 'Tidak ditemukan'
        
    return render(request, 'cariJadwal.html', context)

daftarjadwal/templates/cariJadwal.html
{% include 'base.html' %}
{% load static %}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="{% static 'style.css' %}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>Susun Deadline</title>
    <style>
        #jumbo-index .jumbotron{
            background-size: cover;
            background-position: center;
            height: 650px;
            width: 100%;
        }
    </style>
</head>
<body>
    <section id="jumbo-index">
        <div class="jumbotron jumbotron-fluid">
            <div class="container">
            {% if user.is_authenticated %}
                <div class="container-fluid" style="margin-top: 30px;">
                    <div class="container text-blue" style="height: 640px;">
                        <h1>Ringkasan Tugas</h1>
                        <form action="" method="GET">
                            <input id='search' type="text" placeholder="ketik tugas" name="search">
                            <br>
                            <input type="submit" value="Cari">
                        </form>
                        {% if query %}
                        <div style="width: 70%; max-width: 892px;">
                            <p class="title" style="font-size: 35px;">Hasil pencarian tugas</p>
                            <p class="title" style="font-size: 25px;">"{{ query }}"</p>
                                {% if hasil == 'Tidak ditemukan' %}
                                    <p style="text-align: center;">Tidak Ditemukan</p>
                                {% else %}
                                    {% for tugas in hasil %}
                                    <tr class="table text-blue text-center">
                                    <td> {{tugas.namaMatkul}} </td>
                                    <td> {{tugas.namaTugas}} </td>
                                    <td> {{tugas.Deadline}} </td>
                                    <td> {{tugas.semester}} </td>
                                    </tr> 
                                    {% endfor %}
                                {% endif %}
                    </div>
                    {% endif %}
                </div>
            {% else %}
                <section name="form">
                    <div class="container-fluid">
                        <div class="container text-blue" style="height: 670px;">
                            <h1>Ringkasan Tugas</h1>
                            <h2>Harap Log In terlebih dahulu</h2>
                            <a class="btn btn-primary mt-2" href="{% url 'home:login' %}">Log In</a>
                        </div>
                    </div> 
                </section>
            {% endif %}
            </div>
        </div>
    </section>
</body>
</html>

daftarjadwal/templates/daftarjadwal.html
{% include 'base.html' %}
{% load static %}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="{% static 'style.css' %}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>Susun Deadline</title>
    <style>
        #jumbo-index .jumbotron{
            background-size: cover;
            background-position: center;
            height: 650px;
            width: 100%;
        }
    </style>
</head>
<body>
    <section id="jumbo-index">
        <div class="jumbotron jumbotron-fluid">
            <div class="container">
            {% if user.is_authenticated %}
                <div class="container-fluid" style="margin-top: 30px;">
                    <div class="container text-white" style="height: 640px;">
                        <h1>Ringkasan Tugas</h1>
                        <table class="table">
                            <thead class="table  text-blue text-center">
                                <th scope="col">Mata Kuliah</th>
                                <th scope="col">Nama Tugas</th>
                                <th scope="col">Deadline</th>
                                <th scope="col">Semester</th>
                            </thead>
                            <tbody>
                                {% for a in posts %}
                                <tr class="table text-blue text-center">
                                    <td> {{a.namaMatkul}} </td>
                                    <td> {{a.namaTugas}} </td>
                                    <td> {{a.Deadline}} </td>
                                    <td> {{a.semester}} </td>
                                    <td><a class="btn btn-danger" href="{% url 'daftarjadwal:delete' a.id %}">Delete</a></td>
                                    <td><a class="btn btn-warning" href="{% url 'daftarjadwal:update' a.id %}">Update</a></td>
                                </tr> 
                                {% endfor %}
                            </tbody>
                        </table>
                        <a class="btn btn-primary" href="/susundeadline">Tambahkan Tugas Lain</a>
                    </div>
                </div>
            {% else %}
                <section name="form">
                    <div class="container-fluid">
                        <div class="container text-blue" style="height: 670px;">
                            <h1>Ringkasan Tugas</h1>
                            <h2>Harap Log In terlebih dahulu</h2>
                            <a class="btn btn-primary mt-2" href="{% url 'home:login' %}">Log In</a>
                        </div>
                    </div> 
                </section>
            {% endif %}
            </div>
        </div>
    </section>
</body>
</html>

daftarjadwal/templates/susunjadwal.html
{% include 'base.html' %}
{% load static %}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="{% static 'style.css' %}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>Susun Deadline</title>
</head>
<body>
    <section id="jumbo-index">
        <div class="jumbotron jumbotron-fluid">
            <div class="container">
            {% if user.is_authenticated %}
                <section name="form">
                    <div class="container-fluid">
                        <div class="container text-blue" style="height: 670px;">
                            <h1>Atur Jadwal</h1>
                            <form method = "POST" action="">
                                {% csrf_token %}
                                {% for a in post_form %}
                                <div class="form-group">
                                    {{a.label}}
                                    {{a}}
                                </div>
                                {% endfor %}
                                <button class="btn btn-primary" type="Submit">Submit</button>
                            </form>
                        </div>
                    </div> 
                </section>
            {% else %}
                <section name="form">
                    <div class="container-fluid">
                        <div class="container text-blue" style="height: 670px;">
                            <h1>Atur Jadwal</h1>
                            <h2>Harap Log In terlebih dahulu</h2>
                            <a class="btn btn-primary mt-2" href="{% url 'home:login' %}">Log In</a>
                        </div>
                    </div> 
                </section>
            {% endif %}

            </div>
        </div>
    </section>   
</body>
</html>

<style>
    #jumbo-index .jumbotron{
        background-size: cover;
        background-position: center;
        height: 1100px;
        width: 100%;
    }
    .btn {
        padding: 7px 30px;
        margin-right: 30px;
        outline: none;
        border: 1px solid #fb7381;
        border-radius: 20px;
        cursor: pointer;
        color: #fb7381;
        background: transparent;
    }
    #jumbo-index .jumbotron{
        background-size: cover;
        background-position: center;
        height: 650px;
        width: 100%;
    }
</style>